//判断当前环境是IOS还是安卓
var u = navigator.userAgent;
var app = navigator.appVersion;
var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //g
var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端

var RE = {};

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0
};

RE.editor = document.getElementById('editor');
RE.root = document.getElementById('root');

document.addEventListener("selectionchange", function () {
    RE.backuprange();
});

// Initializations
RE.callback = function () {
    console.log(RE.getHtml());
    console.log(window.webkit, "我是回调");
    if (window.webkit) {
        window.webkit.messageHandlers.textDidChanged.postMessage('1');
    }
    // window.location.href = "re-callback://" + encodeURIComponent(RE.getHtml());
    // setTimeout(function () {
    //     RE.enabledEditingItems();
    // }, 50)
}

RE.setHtml = function (contents) {
    RE.editor.innerHTML = contents;
    // RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
}

RE.getHtml = function () {
    return RE.editor.innerHTML;
}

function getContentData() {
    return RE.editor.innerHTML;
}

// 聚焦富文本
function focuText() {
    RE.editor.focus()
}

// 获取当前页面所有的html
function getHtml() {
    let allHtml = RE.getHtml();
    console.log(allHtml, '我是gethtml获取的内容');
    if (allHtml === '<font><br></font>' || allHtml === '<br>') {
        allHtml = ''
    }

    return encodeURIComponent(allHtml)
}

// 获取富文本标题方法
function getRichTitle() {
    var richText = RE.getText()
    var title = richText.substr(0, 45)
    title = title.replace(/\s/g, '');
    console.log(title);
    return title
}

// 获取图片方法
function getHtmlImg() {
    return document.getElementsByTagName('img')[0].src;
}

RE.getText = function () {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function (color) {
    RE.editor.style.color = color;
}

RE.setBaseFontSize = function (size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function (left, top, right, bottom) {
    RE.editor.style.paddingLeft = left;
    RE.editor.style.paddingTop = top;
    RE.editor.style.paddingRight = right;
    RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function (color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function (image) {
    console.log(image, '接受到的image');
    RE.editor.style.backgroundImage = image;
}

// 设置背景图
function setRickTextBg(params) {
    console.log(params, "我是接受的参数");
    params = JSON.parse(params)
    var bgContent = `url('${params.centerImg}') no-repeat`;
    document.getElementById('root').style.background = bgContent;
    document.getElementById('root').style.backgroundSize = '100% 100%';
}

RE.setWidth = function (size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function (size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function (align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function (align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function (placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.setInputEnabled = function (inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
}

RE.undo = function () {
    document.execCommand('undo', false, null);
    RE.enabledEditingItems()
}

RE.redo = function () {
    document.execCommand('redo', false, null);
    RE.enabledEditingItems()
}

RE.setTextFont = function (name) {
    console.log('fontName= ' + name)
    // RE.root.style.fontFamily = name
    document.execCommand('FontName', 'false', name);
    console.log(RE.getHtml());
}

// 更改文字字体
function setFontFamily(val) {
    RE.setTextFont(val)
}

RE.addAllFont = function (name, url) {
    var dom = document.createElement('style')
    console.log('name= ' + name);
    console.log('url= ' + url);
    dom.innerHTML = `
              @font-face{
                  font-family: '${name}';
                  src : url('${url}');
              }
            `
    dom.setAttribute('id', '${name}')
    document.querySelector('head').append(dom)
}

RE.setBold = function () {
    document.execCommand('bold', false, null);
    RE.enabledEditingItems()
}

RE.setItalic = function () {
    document.execCommand('italic', false, null);
}

RE.setSubscript = function () {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function () {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function () {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function () {
    document.execCommand('underline', false, null);
    RE.enabledEditingItems()
}

RE.setBullets = function () {
    document.execCommand('insertUnorderedList', false, null);
    RE.enabledEditingItems()
}

RE.setNumbers = function () {
    document.execCommand('insertOrderedList', false, null);
    RE.enabledEditingItems()
}

RE.setTextColor = function (color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

// 自定义字体修改
function changeFontFamily(name, url) {
    let fontFamilyPath = `url('${url}')`;
    var myFont = new FontFace(name, fontFamilyPath, {});
    myFont.load().then(function (loadFace) {
        document.fonts.add(loadFace);
    });
    RE.setTextFont(name);
}

// 内容更改为无序列表
function setTextDisorder() {
    RE.setJustifyLeft();
    RE.setBullets();
}

// 取消有序无序列表状态
function remotePrderStetting() {
    RE.setBullets();
}

// 更改文字颜色
function setFontColor(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

// 内容插入图片
function insertImg(val) {
    RE.insertImage(val, '#')
    moveMouse();
    setTimeout(() => {
        gotBottom();
    }, 300);

}

RE.setTextBackgroundColor = function (color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function (fontSize) {
    document.execCommand("fontSize", false, fontSize);
}

// 更改文字大小
function setFontSize(fontSize) {
    console.log(fontSize);

    if (fontSize == 'small') {
        fontSize = 3
    } else if (fontSize == 'medium') {
        fontSize = 4
    } else if (fontSize == 'large') {
        fontSize = 5
    }

    RE.setFontSize(fontSize);
    // RE.editor.style.fontSize = fontSize;
}

// 更改文字对齐方式
function setTextSort(val) {
    console.log(val);
    if (val === 'left') {
        RE.setJustifyLeft();
    } else if (val === 'center') {
        RE.setJustifyCenter();
    } else if (val === 'right') {
        RE.setJustifyRight();
    }
}


// 编辑内容回显
function setHtml(val) {
    console.log(val, "我是回显内容");
    val = decodeURIComponent(val);
    console.log(val, "我是回显转码后的内容");
    RE.setHtml(val)
}

// IOS获取默认的样式
function getDefaultIosCss() {
    var params = {
        fontSize: '中',
        color: '#111111',
    }

    params = JSON.stringify(params)

    return params
}

// 插入文本文字
function noteInsertText(params) {
    RE.insertHTML(params)
}

RE.setHeading = function (heading) {
    document.execCommand('formatBlock', false, '<h' + heading + '>');
}

RE.setIndent = function () {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function () {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function () {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function () {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function () {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function () {
    document.execCommand('formatBlock', false, '<blockquote>');
}

RE.insertImage = function (url, alt) {
    var html = '<img src="' + url + '" alt="' + alt + '" /><br>&nbsp';
    RE.insertHTML(html);
}

RE.insertImageW = function (url, alt, width) {
    var html = '<img src="' + url + '" alt="' + alt + '" width="' + width + '"/>';
    RE.insertHTML(html);
}

RE.insertImageWH = function (url, alt, width, height) {
    var html = '<img src="' + url + '" alt="' + alt + '" width="' + width + '" height="' + height + '"/>';
    RE.insertHTML(html);
}

RE.insertVideo = function (url, alt) {
    var html = '<video src="' + url + '" controls></video><br>';
    RE.insertHTML(html);
}

RE.insertVideoW = function (url, width) {
    var html = '<video src="' + url + '" width="' + width + '" controls></video><br>';
    RE.insertHTML(html);
}

RE.insertVideoWH = function (url, width, height) {
    var html = '<video src="' + url + '" width="' + width + '" height="' + height + '" controls></video><br>';
    RE.insertHTML(html);
}

RE.insertAudio = function (url, alt) {
    var html = '<audio src="' + url + '" controls></audio><br>';
    RE.insertHTML(html);
}

RE.insertHTML = function (html) {
    // RE.restorerange();
    document.execCommand('insertHTML', false, html);
}

RE.insertLink = function (url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString()
        .length == 0) {
        document.execCommand("insertHTML", false, "<a href='" + url + "'>" + title + "</a>");
    } else if (sel.rangeCount) {
        var el = document.createElement("a");
        el.setAttribute("href", url);
        el.setAttribute("title", title);

        var range = sel.getRangeAt(0)
            .cloneRange();
        range.surroundContents(el);
        sel.removeAllRanges();
        sel.addRange(range);
    }
    RE.callback();
}

RE.setTodo = function (text) {
    var html = '<input type="checkbox" name="' + text + '" value="' + text + '"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function () {
    RE.backuprange();
}

RE.backuprange = function () {
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        RE.currentSelection = {
            "startContainer": range.startContainer,
            "startOffset": range.startOffset,
            "endContainer": range.endContainer,
            "endOffset": range.endOffset
        };
    }
}

RE.restorerange = function () {
    var selection = window.getSelection();
    console.log(selection, "我是光标对象");
    // selection.removeAllRanges();
    // var range = document.createRange();
    // range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    // range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    // selection.addRange(range);
}

RE.enabledEditingItems = function (e) {
    getRangeDomCss();
    return;
}

function getRangeDomCss() {
    var letrange = window.getSelection().getRangeAt(0);
    console.log(letrange, "我是letrange");
    var target = letrange.commonAncestorContainer.parentElement
    console.log(target, "我是getRangeDomCss的 target");
    var selectCss = {
        fontSize: '',
        color: '',
        fontFamily: '',
        isListItem: false,
        textAlign: '',
        isImage: false
    }
    var items = []
    console.log(target.nodeName);
    if (target.nodeName === "LI") {
        selectCss.isListItem = true

    } else {
        selectCss.isListItem = false
    }

    if (target.nodeName === 'FONT') {
        if (target.color.length > 0) {
            console.log(target.color, 1.1);
            selectCss.color = target.color;
        } else if (target.style.color.length > 0) {
            selectCss.color = target.style.color;
        } else {
            selectCss.color = checkParentCss('color', target.parentElement)
            console.log(selectCss, "转换前的selectCss");
        }
        console.log(target.face);
        if (target.face.length > 0) {
            selectCss.fontFamily = target.face;
        } else {
            selectCss.fontFamily = checkParentCss('face', target.parentElement)
        }
        console.log(target.size);
        if (target.size.length > 0) {
            if (target.size == 3) {
                selectCss.fontSize = 'small';
            } else if (target.size == 4) {
                selectCss.fontSize = 'medium';
            } else if (target.size == 5) {
                selectCss.fontSize = 'large';
            }
        } else {
            selectCss.fontSize = checkParentCss('size', target.parentElement)
        }

    } else {
        if (target.style.color.length > 0) {
            selectCss.color = target.style.color;
        } else {
            selectCss.color = checkParentCss('color', target.parentElement)
        }
    }

    if (target.nodeName === "IMG") {
        selectCss.isImage = true
    }

    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        selectCss.isListItem = true;
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        selectCss.textAlign = 'center';
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        selectCss.textAlign = 'left';
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        selectCss.textAlign = 'right';
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    console.log(selectCss, "转换前的selectCss");

    if (typeof selectCss.color !== 'string') {
        selectCss.color = ''
    } else if (typeof selectCss.fontSize !== 'string') {
        selectCss.fontSize = ''
    } else if (typeof selectCss.fontFamily !== 'string') {
        selectCss.fontFamily = ''
    }

    console.log(selectCss, "我是鼠标点击获取到回显内容");

    selectCss = JSON.stringify(selectCss)


    if (window.callback) {
        window.callback.onCursorFocusCallback(selectCss)
    }
    if (window.webkit) {
        window.webkit.messageHandlers.onCursorFocusCallback.postMessage(selectCss);
    }
}

function checkParentCss(valName, valDom) {
    var target = valDom
    var targetResult = ''
    console.log(target, "我是checkParentCss的 target");
    var selectCss = {
        fontSize: '',
        color: '',
        fontFamily: '',
        isListItem: false,
        textAlign: '',
        isImage: false
    }
    var items = []

    if (valName === 'color') {
        if (target.nodeName === 'FONT') {
            if (target.color.length > 0) {
                targetResult = target.color;
            } else if (target.style.color.length > 0) {
                console.log(target.style.color, '进入font的style查询颜色');
                targetResult = target.style.color;
            } else {
                // targetResult = checkParentCss('color', target.parentElement)
            }
        } else {
            if (target.style && target.style.color.length > 0) {
                targetResult = target.style.color;
            } else {
                // targetResult = checkParentCss('color', target.parentElement)
            }
        }
        console.log(10.8, targetResult);
        if (targetResult && targetResult.length > 0) {
            return targetResult;
        }
    }

    if (valName === 'size') {
        if (target.nodeName === 'FONT') {
            console.log(target.size);
            if (target.size.length > 0) {
                if (target.size == 3) {
                    targetResult = 'small';
                } else if (target.size == 4) {
                    targetResult = 'medium';
                } else if (target.size == 5) {
                    targetResult = 'large';
                }
            } else {
                // targetResult = checkParentCss('size', target.parentElement)
            }

        }
        if (targetResult && targetResult.length > 0) {
            return targetResult;
        }
    }

    if (valName === 'face') {
        console.log(11.1);
        if (target.nodeName === 'FONT') {
            console.log(11.2);
            if (target.face.length > 0) {
                targetResult = target.face;
            }
        } else {
            if (target.style) {
                targetResult = target.style.fontFamily
            } else {
                return '';
            }

        }
        if (targetResult && targetResult.length > 0) {
            return targetResult;
        } else {
            return '';
        }
    }

    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        selectCss.isListItem = true;
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        selectCss.textAlign = 'center';
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        selectCss.textAlign = 'left';
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        selectCss.textAlign = 'right';
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }
}


function getCurrCursorAttr() {
    var letrange = window.getSelection().getRangeAt(0);
    var target = letrange.commonAncestorContainer.parentElement
    console.log(target, "我是getCurrCursorAttr的  target");

    if (target.id === 'root' || target.id === 'editor' || target.nodeName === 'BR') {
        getLastDomCss();
        return;
    }

    var selectCss = {
        fontSize: '',
        color: '',
        fontFamily: '',
        isListItem: false,
        textAlign: '',
        isImage: false
    }
    var items = []
    console.log(target.nodeName);
    if (target.nodeName === "LI") {
        selectCss.isListItem = true

    } else {
        selectCss.isListItem = false
    }

    if (target.nodeName === 'FONT') {
        if (target.color.length > 0) {
            console.log(target.color, 1.1);
            selectCss.color = target.color;
        } else if (target.style.color.length > 0) {
            selectCss.color = target.style.color;
        } else {
            selectCss.color = checkParentCss('color', target.parentElement)
            console.log(selectCss, "转换前的selectCss");
        }
        console.log(target.face);
        if (target.face.length > 0) {
            selectCss.fontFamily = target.face;
        } else {
            selectCss.fontFamily = checkParentCss('face', target.parentElement)
        }
        console.log(target.size);
        if (target.size.length > 0) {
            if (target.size == 3) {
                selectCss.fontSize = 'small';
            } else if (target.size == 4) {
                selectCss.fontSize = 'medium';
            } else if (target.size == 5) {
                selectCss.fontSize = 'large';
            }
        } else {
            selectCss.fontSize = checkParentCss('size', target.parentElement)
        }

    } else {
        if (target.style.color.length > 0) {
            selectCss.color = target.style.color;
        } else {
            selectCss.color = checkParentCss('color', target.parentElement)
        }
    }

    if (target.nodeName === "IMG") {
        selectCss.isImage = true
    }

    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        selectCss.isListItem = true;
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        selectCss.textAlign = 'center';
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        selectCss.textAlign = 'left';
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        selectCss.textAlign = 'right';
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    console.log(selectCss, "转换前的selectCss");

    if (typeof selectCss.color !== 'string') {
        selectCss.color = ''
    } else if (typeof selectCss.fontSize !== 'string') {
        selectCss.fontSize = ''
    } else if (typeof selectCss.fontFamily !== 'string') {
        selectCss.fontFamily = ''
    }

    console.log(selectCss, "我是鼠标点击获取到回显内容");
    if (selectCss.color.indexOf('#') == -1) {
        var hexColor = setRgbTo16(selectCss.color);
        console.log(hexColor, "我是转换后的颜色");
    }

    selectCss = JSON.stringify(selectCss)

    if (window.callback) {
        window.callback.onCursorFocusCallback(selectCss)
    }
    if (window.webkit) {
        window.webkit.messageHandlers.onCursorFocusCallback.postMessage(selectCss);
    }

    return encodeURIComponent(selectCss)
}

function setRgbTo16(str) {
    let reg = /^(rgb|RGB)/;
    if (!reg.test(str)) { return; }
    // 将str中的数字提取出来放进数组中
    var arr = str.slice(4, str.length - 1).split(",");
    let c = '#';
    for (var i = 0; i < arr.length; i++) {
        // Number() 函数把对象的值转换为数字
        // toString(16) 将数字转换为十六进制的字符表示
        var t = Number(arr[i]).toString(16);
        //如果小于16，需要补0操作,否则只有5位数
        if (Number(arr[i]) < 16) {
            t = '0' + t;
        }
        c += t;
    }
    return c;
}


// 获取最后一个元素的dom值
function getLastDomCss() {
    console.log('j进入getLastDomCss方法');
    var lastDom = document.getElementById('editor').lastChild;
    console.log(lastDom, "我是最后的dom元素");

    if (typeof lastDom === 'null') {
        return ;
    }

    if (lastDom.nodeName == '#text' || lastDom.nodeName == 'BR') {
        return;
    }
    var items = []

    var selectCss = {
        fontSize: '',
        color: '',
        fontFamily: '',
        isListItem: false,
        textAlign: '',
        isImage: false
    }

    if (lastDom.nodeName === "FONT") {
        if (lastDom.color.length > 0) {
            selectCss.color = lastDom.color;
        } else if (lastDom.style.color.length > 0) {
            selectCss.color = lastDom.style.color;
        } else {
            console.log('lastDom获取到颜色');
            selectCss.color = checkParentCss('color', lastDom.lastChild)
        }
        if (lastDom.face.length > 0) {
            selectCss.fontFamily = lastDom.face;
        } else {
            selectCss.fontFamily = checkParentCss('face', lastDom.lastChild)
        }
        if (lastDom.size.length > 0) {
            if (lastDom.size == 3) {
                selectCss.fontSize = 'small';
            } else if (lastDom.size == 4) {
                selectCss.fontSize = 'medium';
            } else if (lastDom.size == 5) {
                selectCss.fontSize = 'large';
            }
        } else {
            selectCss.fontSize = checkParentCss('size', lastDom.lastChild)
        }
    } else {
        if (lastDom.style.color.length > 0) {
            selectCss.color = lastDom.style.color;
        } else {
            selectCss.color = checkParentCss('color', lastDom.lastChild)
            console.log(selectCss.color, 'lastDom获取到颜色1');
            if ((typeof selectCss.color !== 'string' || selectCss.color == '') && lastDom.lastChild.lastChild) {
                selectCss.color = checkParentCss('color', lastDom.lastChild.lastChild)
                console.log(selectCss.color, 'lastDom获取到颜色2');
                if ((typeof selectCss.color !== 'string' || selectCss.color == '') && lastDom.lastChild.lastChild.lastChild) {
                    selectCss.color = checkParentCss('color', lastDom.lastChild.lastChild.lastChild)
                    console.log(selectCss.color, 'lastDom获取到颜色3');
                }
            }
        }

        if (lastDom.style.fontFamily.length > 0) {
            console.log('开始检测字体');
            selectCss.fontFamily = lastDom.style.fontFamily;
        } else {
            selectCss.fontFamily = checkParentCss('face', lastDom.lastChild)
            console.log(selectCss.fontFamily, '开始下一级检测字体');
            if ((typeof selectCss.fontFamily !== 'string' || selectCss.fontFamily == '') && lastDom.lastChild.lastChild) {
                console.log(selectCss.fontFamily, '开始下两级检测字体');
                selectCss.fontFamily = checkParentCss('face', lastDom.lastChild.lastChild)
                console.log(selectCss.fontFamily, "我是查到的字体");
                if ((typeof selectCss.fontFamily !== 'string' || selectCss.fontFamily == '') && lastDom.lastChild.lastChild.lastChild) {
                    selectCss.fontFamily = checkParentCss('face', lastDom.lastChild.lastChild.lastChild)
                    console.log(selectCss.fontFamily, '开始下三级检测字体');
                }
            }
        }

        if (lastDom.style.fontSize.length > 0) {
            if (lastDom.style.fontSize == 3) {
                selectCss.fontSize = 'small';
            } else if (lastDom.style.fontSize == 4) {
                selectCss.fontSize = 'medium';
            } else if (lastDom.style.fontSize == 5) {
                selectCss.fontSize = 'large';
            }
        } else {
            selectCss.fontSize = checkParentCss('size', lastDom.lastChild)
            console.log(selectCss.fontSize, "我是查到的字号");
            if ((typeof selectCss.fontSize !== 'string' || selectCss.fontSize == '') && lastDom.lastChild.lastChild) {
                selectCss.fontSize = checkParentCss('size', lastDom.lastChild.lastChild)
                if ((typeof selectCss.fontSize !== 'string' || selectCss.fontSize == '') && lastDom.lastChild.lastChild.lastChild) {
                    selectCss.fontSize = checkParentCss('size', lastDom.lastChild.lastChild.lastChild)
                }
            }
        }
    }

    if (lastDom.nodeName === "IMG") {
        selectCss.isImage = true
    }

    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        selectCss.isListItem = true;
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        selectCss.textAlign = 'center';
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        selectCss.textAlign = 'left';
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        selectCss.textAlign = 'right';
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    if (typeof selectCss.color !== 'string') {
        selectCss.color = ''
    } else if (typeof selectCss.fontSize !== 'string') {
        selectCss.fontSize = ''
    } else if (typeof selectCss.fontFamily !== 'string') {
        selectCss.fontFamily = ''
    }

    console.log(selectCss, "我是获取到最后一个dom元素的内容");

    selectCss = JSON.stringify(selectCss)

    if (window.callback) {
        window.callback.onCursorFocusCallback(selectCss)
    }
    if (window.webkit) {
        window.webkit.messageHandlers.onCursorFocusCallback.postMessage(selectCss);
    }
}

// 光标移动到最后一个字
function moveMouse() {
    keepLastIndex(RE.editor)
    getLastDomCss();
}

function keepLastIndex(obj) {
    if (window.getSelection) {//ie11 10 9 ff safari
        obj.focus(); //解决ff不获取焦点无法定位问题
        var range = window.getSelection();//创建range
        range.selectAllChildren(obj);//range 选择obj下所有子内容
        range.collapseToEnd();//光标移至最后
    }
    else if (document.selection) {//ie10 9 8 7 6 5
        var range = document.selection.createRange();//创建选择对象
        //var range = document.body.createTextRange();
        range.moveToElementText(obj);//range定位到obj
        range.collapse(false);//光标移至最后
        range.select();
    }
}

// 富文本滑动底部
function gotBottom() {
    console.log('滑动的底部');
    document.getElementById('root').scrollTop = document.getElementById('root').scrollHeight;
    getCurrCursorAttr();
}

RE.focus = function () {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    RE.editor.focus();
}

RE.blurFocus = function () {
    RE.editor.blur();
}

RE.removeFormat = function () {
    document.execCommand('removeFormat', false, null);
}

// 

// Event Listeners
RE.editor.addEventListener("input", RE.callback);
RE.editor.addEventListener("keyup", function (e) {
    getRangeDomCss();
});

RE.editor.addEventListener("click", RE.enabledEditingItems);

if (isIOS) {
    RE.editor.addEventListener("touchmove", RE.enabledEditingItems);
}
